import * as axios from 'axios';
import { AxiosRequestConfig, AxiosInstance, AxiosPromise } from 'axios';

/**
 * Dopt Blocks API
 * The Dopt Blocks API
 *
 * The version of the OpenAPI document: 0.0.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
interface ConfigurationParameters {
    apiKey?: string | Promise<string> | ((name: string) => string) | ((name: string) => Promise<string>);
    username?: string;
    password?: string;
    accessToken?: string | Promise<string> | ((name?: string, scopes?: string[]) => string) | ((name?: string, scopes?: string[]) => Promise<string>);
    basePath?: string;
    baseOptions?: any;
    formDataCtor?: new () => any;
}
declare class Configuration {
    /**
     * parameter for apiKey security
     * @param name security name
     * @memberof Configuration
     */
    apiKey?: string | Promise<string> | ((name: string) => string) | ((name: string) => Promise<string>);
    /**
     * parameter for basic security
     *
     * @type {string}
     * @memberof Configuration
     */
    username?: string;
    /**
     * parameter for basic security
     *
     * @type {string}
     * @memberof Configuration
     */
    password?: string;
    /**
     * parameter for oauth2 security
     * @param name security name
     * @param scopes oauth2 scope
     * @memberof Configuration
     */
    accessToken?: string | Promise<string> | ((name?: string, scopes?: string[]) => string) | ((name?: string, scopes?: string[]) => Promise<string>);
    /**
     * override base path
     *
     * @type {string}
     * @memberof Configuration
     */
    basePath?: string;
    /**
     * base options for axios calls
     *
     * @type {any}
     * @memberof Configuration
     */
    baseOptions?: any;
    /**
     * The FormData constructor that will be used to create multipart form data
     * requests. You can inject this here so that execution environments that
     * do not support the FormData class can still run the generated client.
     *
     * @type {new () => FormData}
     */
    formDataCtor?: new () => any;
    constructor(param?: ConfigurationParameters);
    /**
     * Check if the given MIME is a JSON MIME.
     * JSON MIME examples:
     *   application/json
     *   application/json; charset=UTF8
     *   APPLICATION/JSON
     *   application/vnd.company+json
     * @param mime - MIME (Multipurpose Internet Mail Extensions)
     * @return True if the given MIME is JSON, false otherwise.
     */
    isJsonMime(mime: string): boolean;
}

/**
 * Dopt Blocks API
 * The Dopt Blocks API
 *
 * The version of the OpenAPI document: 0.0.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

/**
 *
 * @export
 * @interface RequestArgs
 */
interface RequestArgs {
    url: string;
    options: AxiosRequestConfig;
}
/**
 *
 * @export
 * @class BaseAPI
 */
declare class BaseAPI {
    protected basePath: string;
    protected axios: AxiosInstance;
    protected configuration: Configuration | undefined;
    constructor(configuration?: Configuration, basePath?: string, axios?: AxiosInstance);
}

/**
 *
 * @export
 * @interface BadRequestErrorResponseBody
 */
interface BadRequestErrorResponseBody {
    /**
     *
     * @type {BadRequestErrorResponseBody1Code}
     * @memberof BadRequestErrorResponseBody
     */
    'code': BadRequestErrorResponseBody1Code;
    /**
     *
     * @type {string}
     * @memberof BadRequestErrorResponseBody
     */
    'details': string;
}
/**
 *
 * @export
 * @interface BadRequestErrorResponseBody1
 */
interface BadRequestErrorResponseBody1 {
    /**
     *
     * @type {BadRequestErrorResponseBody1Code}
     * @memberof BadRequestErrorResponseBody1
     */
    'code': BadRequestErrorResponseBody1Code;
    /**
     *
     * @type {string}
     * @memberof BadRequestErrorResponseBody1
     */
    'details': string;
}
/**
 *
 * @export
 * @interface BadRequestErrorResponseBody1Code
 */
interface BadRequestErrorResponseBody1Code {
}
/**
 *
 * @export
 * @enum {string}
 */
declare const BadRequestErrorResponseBody1CodeAnyOf: {
    readonly InvalidRequestError: "invalid_request_error";
};
type BadRequestErrorResponseBody1CodeAnyOf = typeof BadRequestErrorResponseBody1CodeAnyOf[keyof typeof BadRequestErrorResponseBody1CodeAnyOf];
/**
 *
 * @export
 * @enum {string}
 */
declare const BadRequestErrorResponseBody1CodeAnyOf1: {
    readonly IntentRequestError: "intent_request_error";
};
type BadRequestErrorResponseBody1CodeAnyOf1 = typeof BadRequestErrorResponseBody1CodeAnyOf1[keyof typeof BadRequestErrorResponseBody1CodeAnyOf1];
/**
 *
 * @export
 * @interface BlockTransitionQueryString
 */
interface BlockTransitionQueryString {
    /**
     *
     * @type {Set<string>}
     * @memberof BlockTransitionQueryString
     */
    'transitions': Set<string>;
    /**
     *
     * @type {number}
     * @memberof BlockTransitionQueryString
     */
    'version': number;
    /**
     *
     * @type {string}
     * @memberof BlockTransitionQueryString
     */
    'userIdentifier': string;
    /**
     *
     * @type {string}
     * @memberof BlockTransitionQueryString
     */
    'groupIdentifier'?: string;
}
/**
 *
 * @export
 * @interface BlockTransitionRequestParams
 */
interface BlockTransitionRequestParams {
    /**
     *
     * @type {string}
     * @memberof BlockTransitionRequestParams
     */
    'uid': string;
}
/**
 *
 * @export
 * @interface FindBlocks200Response
 */
interface FindBlocks200Response {
    /**
     *
     * @type {string}
     * @memberof FindBlocks200Response
     */
    'kind': FindBlocks200ResponseKindEnum;
    /**
     *
     * @type {string}
     * @memberof FindBlocks200Response
     */
    'uid': string;
    /**
     *
     * @type {string}
     * @memberof FindBlocks200Response
     */
    'sid': string;
    /**
     *
     * @type {number}
     * @memberof FindBlocks200Response
     */
    'version': number;
    /**
     *
     * @type {FindBlocks200ResponseState}
     * @memberof FindBlocks200Response
     */
    'state': FindBlocks200ResponseState;
    /**
     *
     * @type {{ [key: string]: boolean; }}
     * @memberof FindBlocks200Response
     */
    'transitioned': {
        [key: string]: boolean;
    };
    /**
     *
     * @type {string}
     * @memberof FindBlocks200Response
     */
    'type': FindBlocks200ResponseTypeEnum;
    /**
     *
     * @type {Array<FindBlocks200ResponseFieldsInner>}
     * @memberof FindBlocks200Response
     */
    'fields': Array<FindBlocks200ResponseFieldsInner>;
}
declare const FindBlocks200ResponseKindEnum: {
    readonly Block: "block";
};
type FindBlocks200ResponseKindEnum = typeof FindBlocks200ResponseKindEnum[keyof typeof FindBlocks200ResponseKindEnum];
declare const FindBlocks200ResponseTypeEnum: {
    readonly Model: "model";
};
type FindBlocks200ResponseTypeEnum = typeof FindBlocks200ResponseTypeEnum[keyof typeof FindBlocks200ResponseTypeEnum];
/**
 *
 * @export
 * @interface FindBlocks200ResponseFieldsInner
 */
interface FindBlocks200ResponseFieldsInner {
    /**
     *
     * @type {string}
     * @memberof FindBlocks200ResponseFieldsInner
     */
    'sid': string;
    /**
     *
     * @type {string}
     * @memberof FindBlocks200ResponseFieldsInner
     */
    'type': FindBlocks200ResponseFieldsInnerTypeEnum;
    /**
     *
     * @type {FindBlocks200ResponseFieldsInnerAnyOf2Value}
     * @memberof FindBlocks200ResponseFieldsInner
     */
    'value': FindBlocks200ResponseFieldsInnerAnyOf2Value;
}
declare const FindBlocks200ResponseFieldsInnerTypeEnum: {
    readonly Boolean: "boolean";
};
type FindBlocks200ResponseFieldsInnerTypeEnum = typeof FindBlocks200ResponseFieldsInnerTypeEnum[keyof typeof FindBlocks200ResponseFieldsInnerTypeEnum];
/**
 *
 * @export
 * @interface FindBlocks200ResponseFieldsInnerAnyOf
 */
interface FindBlocks200ResponseFieldsInnerAnyOf {
    /**
     *
     * @type {string}
     * @memberof FindBlocks200ResponseFieldsInnerAnyOf
     */
    'sid': string;
    /**
     *
     * @type {string}
     * @memberof FindBlocks200ResponseFieldsInnerAnyOf
     */
    'type': FindBlocks200ResponseFieldsInnerAnyOfTypeEnum;
    /**
     *
     * @type {FindBlocks200ResponseFieldsInnerAnyOfValue}
     * @memberof FindBlocks200ResponseFieldsInnerAnyOf
     */
    'value': FindBlocks200ResponseFieldsInnerAnyOfValue;
}
declare const FindBlocks200ResponseFieldsInnerAnyOfTypeEnum: {
    readonly String: "string";
};
type FindBlocks200ResponseFieldsInnerAnyOfTypeEnum = typeof FindBlocks200ResponseFieldsInnerAnyOfTypeEnum[keyof typeof FindBlocks200ResponseFieldsInnerAnyOfTypeEnum];
/**
 *
 * @export
 * @interface FindBlocks200ResponseFieldsInnerAnyOf1
 */
interface FindBlocks200ResponseFieldsInnerAnyOf1 {
    /**
     *
     * @type {string}
     * @memberof FindBlocks200ResponseFieldsInnerAnyOf1
     */
    'sid': string;
    /**
     *
     * @type {string}
     * @memberof FindBlocks200ResponseFieldsInnerAnyOf1
     */
    'type': FindBlocks200ResponseFieldsInnerAnyOf1TypeEnum;
    /**
     *
     * @type {FindBlocks200ResponseFieldsInnerAnyOf1Value}
     * @memberof FindBlocks200ResponseFieldsInnerAnyOf1
     */
    'value': FindBlocks200ResponseFieldsInnerAnyOf1Value;
}
declare const FindBlocks200ResponseFieldsInnerAnyOf1TypeEnum: {
    readonly Number: "number";
};
type FindBlocks200ResponseFieldsInnerAnyOf1TypeEnum = typeof FindBlocks200ResponseFieldsInnerAnyOf1TypeEnum[keyof typeof FindBlocks200ResponseFieldsInnerAnyOf1TypeEnum];
/**
 *
 * @export
 * @interface FindBlocks200ResponseFieldsInnerAnyOf1Value
 */
interface FindBlocks200ResponseFieldsInnerAnyOf1Value {
}
/**
 *
 * @export
 * @interface FindBlocks200ResponseFieldsInnerAnyOf2
 */
interface FindBlocks200ResponseFieldsInnerAnyOf2 {
    /**
     *
     * @type {string}
     * @memberof FindBlocks200ResponseFieldsInnerAnyOf2
     */
    'sid': string;
    /**
     *
     * @type {string}
     * @memberof FindBlocks200ResponseFieldsInnerAnyOf2
     */
    'type': FindBlocks200ResponseFieldsInnerAnyOf2TypeEnum;
    /**
     *
     * @type {FindBlocks200ResponseFieldsInnerAnyOf2Value}
     * @memberof FindBlocks200ResponseFieldsInnerAnyOf2
     */
    'value': FindBlocks200ResponseFieldsInnerAnyOf2Value;
}
declare const FindBlocks200ResponseFieldsInnerAnyOf2TypeEnum: {
    readonly Boolean: "boolean";
};
type FindBlocks200ResponseFieldsInnerAnyOf2TypeEnum = typeof FindBlocks200ResponseFieldsInnerAnyOf2TypeEnum[keyof typeof FindBlocks200ResponseFieldsInnerAnyOf2TypeEnum];
/**
 *
 * @export
 * @interface FindBlocks200ResponseFieldsInnerAnyOf2Value
 */
interface FindBlocks200ResponseFieldsInnerAnyOf2Value {
}
/**
 *
 * @export
 * @interface FindBlocks200ResponseFieldsInnerAnyOfValue
 */
interface FindBlocks200ResponseFieldsInnerAnyOfValue {
}
/**
 *
 * @export
 * @interface FindBlocks200ResponseState
 */
interface FindBlocks200ResponseState {
    /**
     *
     * @type {boolean}
     * @memberof FindBlocks200ResponseState
     */
    'active': boolean;
    /**
     *
     * @type {boolean}
     * @memberof FindBlocks200ResponseState
     */
    'entered': boolean;
    /**
     *
     * @type {boolean}
     * @memberof FindBlocks200ResponseState
     */
    'exited': boolean;
}
/**
 *
 * @export
 * @enum {string}
 */
declare const FinishIntent: {
    readonly Finish: "finish";
};
type FinishIntent = typeof FinishIntent[keyof typeof FinishIntent];
/**
 *
 * @export
 * @interface FlowIntent
 */
interface FlowIntent {
}
/**
 *
 * @export
 * @interface FlowIntentQueryString
 */
interface FlowIntentQueryString {
    /**
     *
     * @type {number}
     * @memberof FlowIntentQueryString
     */
    'version': number;
    /**
     *
     * @type {string}
     * @memberof FlowIntentQueryString
     */
    'userIdentifier': string;
    /**
     *
     * @type {string}
     * @memberof FlowIntentQueryString
     */
    'groupIdentifier'?: string;
}
/**
 *
 * @export
 * @interface FlowIntentRequestParams
 */
interface FlowIntentRequestParams {
    /**
     *
     * @type {string}
     * @memberof FlowIntentRequestParams
     */
    'uid': string;
    /**
     *
     * @type {FlowIntent}
     * @memberof FlowIntentRequestParams
     */
    'intent': FlowIntent;
}
/**
 *
 * @export
 * @interface GetBlockQueryString
 */
interface GetBlockQueryString {
    /**
     *
     * @type {number}
     * @memberof GetBlockQueryString
     */
    'version': number;
    /**
     *
     * @type {string}
     * @memberof GetBlockQueryString
     */
    'userIdentifier': string;
}
/**
 *
 * @export
 * @interface GetBlockRequestParams
 */
interface GetBlockRequestParams {
    /**
     *
     * @type {string}
     * @memberof GetBlockRequestParams
     */
    'uid': string;
}
/**
 *
 * @export
 * @interface GetFlow200Response
 */
interface GetFlow200Response {
    /**
     *
     * @type {string}
     * @memberof GetFlow200Response
     */
    'kind': GetFlow200ResponseKindEnum;
    /**
     *
     * @type {string}
     * @memberof GetFlow200Response
     */
    'type': GetFlow200ResponseTypeEnum;
    /**
     *
     * @type {string}
     * @memberof GetFlow200Response
     */
    'uid': string;
    /**
     *
     * @type {string}
     * @memberof GetFlow200Response
     */
    'sid': string;
    /**
     *
     * @type {number}
     * @memberof GetFlow200Response
     */
    'version': number;
    /**
     *
     * @type {GetFlow200ResponseState}
     * @memberof GetFlow200Response
     */
    'state': GetFlow200ResponseState;
    /**
     *
     * @type {Array<FindBlocks200Response>}
     * @memberof GetFlow200Response
     */
    'blocks'?: Array<FindBlocks200Response>;
}
declare const GetFlow200ResponseKindEnum: {
    readonly Flow: "flow";
};
type GetFlow200ResponseKindEnum = typeof GetFlow200ResponseKindEnum[keyof typeof GetFlow200ResponseKindEnum];
declare const GetFlow200ResponseTypeEnum: {
    readonly Flow: "flow";
};
type GetFlow200ResponseTypeEnum = typeof GetFlow200ResponseTypeEnum[keyof typeof GetFlow200ResponseTypeEnum];
/**
 *
 * @export
 * @interface GetFlow200ResponseState
 */
interface GetFlow200ResponseState {
    /**
     *
     * @type {boolean}
     * @memberof GetFlow200ResponseState
     */
    'stopped': boolean;
    /**
     *
     * @type {boolean}
     * @memberof GetFlow200ResponseState
     */
    'started': boolean;
    /**
     *
     * @type {boolean}
     * @memberof GetFlow200ResponseState
     */
    'finished': boolean;
}
/**
 *
 * @export
 * @interface GetFlowQueryString
 */
interface GetFlowQueryString {
    /**
     *
     * @type {number}
     * @memberof GetFlowQueryString
     */
    'version': number;
    /**
     *
     * @type {string}
     * @memberof GetFlowQueryString
     */
    'include'?: GetFlowQueryStringIncludeEnum;
    /**
     *
     * @type {string}
     * @memberof GetFlowQueryString
     */
    'userIdentifier': string;
}
declare const GetFlowQueryStringIncludeEnum: {
    readonly Block: "block";
};
type GetFlowQueryStringIncludeEnum = typeof GetFlowQueryStringIncludeEnum[keyof typeof GetFlowQueryStringIncludeEnum];
/**
 *
 * @export
 * @interface GetFlowRequestParams
 */
interface GetFlowRequestParams {
    /**
     *
     * @type {string}
     * @memberof GetFlowRequestParams
     */
    'sid': string;
}
/**
 *
 * @export
 * @interface HealthCheckResponseBody
 */
interface HealthCheckResponseBody {
    /**
     *
     * @type {string}
     * @memberof HealthCheckResponseBody
     */
    'application': string;
    /**
     *
     * @type {number}
     * @memberof HealthCheckResponseBody
     */
    'status': number;
}
/**
 *
 * @export
 * @interface InternalServerErrorResponseBody
 */
interface InternalServerErrorResponseBody {
    /**
     *
     * @type {InternalServerErrorResponseBody1Code}
     * @memberof InternalServerErrorResponseBody
     */
    'code': InternalServerErrorResponseBody1Code;
    /**
     *
     * @type {string}
     * @memberof InternalServerErrorResponseBody
     */
    'details': string;
}
/**
 *
 * @export
 * @interface InternalServerErrorResponseBody1
 */
interface InternalServerErrorResponseBody1 {
    /**
     *
     * @type {InternalServerErrorResponseBody1Code}
     * @memberof InternalServerErrorResponseBody1
     */
    'code': InternalServerErrorResponseBody1Code;
    /**
     *
     * @type {string}
     * @memberof InternalServerErrorResponseBody1
     */
    'details': string;
}
/**
 *
 * @export
 * @interface InternalServerErrorResponseBody1Code
 */
interface InternalServerErrorResponseBody1Code {
}
/**
 *
 * @export
 * @enum {string}
 */
declare const InternalServerErrorResponseBody1CodeAnyOf: {
    readonly InternalServerError: "internal_server_error";
};
type InternalServerErrorResponseBody1CodeAnyOf = typeof InternalServerErrorResponseBody1CodeAnyOf[keyof typeof InternalServerErrorResponseBody1CodeAnyOf];
/**
 *
 * @export
 * @interface NotFoundErrorResponseBody
 */
interface NotFoundErrorResponseBody {
    /**
     *
     * @type {NotFoundErrorResponseBody1Code}
     * @memberof NotFoundErrorResponseBody
     */
    'code': NotFoundErrorResponseBody1Code;
    /**
     *
     * @type {string}
     * @memberof NotFoundErrorResponseBody
     */
    'details': string;
}
/**
 *
 * @export
 * @interface NotFoundErrorResponseBody1
 */
interface NotFoundErrorResponseBody1 {
    /**
     *
     * @type {NotFoundErrorResponseBody1Code}
     * @memberof NotFoundErrorResponseBody1
     */
    'code': NotFoundErrorResponseBody1Code;
    /**
     *
     * @type {string}
     * @memberof NotFoundErrorResponseBody1
     */
    'details': string;
}
/**
 *
 * @export
 * @interface NotFoundErrorResponseBody1Code
 */
interface NotFoundErrorResponseBody1Code {
}
/**
 *
 * @export
 * @enum {string}
 */
declare const NotFoundErrorResponseBody1CodeAnyOf: {
    readonly NotFoundError: "not_found_error";
};
type NotFoundErrorResponseBody1CodeAnyOf = typeof NotFoundErrorResponseBody1CodeAnyOf[keyof typeof NotFoundErrorResponseBody1CodeAnyOf];
/**
 *
 * @export
 * @enum {string}
 */
declare const ResetIntent: {
    readonly Reset: "reset";
};
type ResetIntent = typeof ResetIntent[keyof typeof ResetIntent];
/**
 *
 * @export
 * @enum {string}
 */
declare const StartIntent: {
    readonly Start: "start";
};
type StartIntent = typeof StartIntent[keyof typeof StartIntent];
/**
 *
 * @export
 * @enum {string}
 */
declare const StopIntent: {
    readonly Stop: "stop";
};
type StopIntent = typeof StopIntent[keyof typeof StopIntent];
/**
 *
 * @export
 * @interface TimeoutErrorResponseBody
 */
interface TimeoutErrorResponseBody {
    /**
     *
     * @type {InternalServerErrorResponseBody1Code}
     * @memberof TimeoutErrorResponseBody
     */
    'code': InternalServerErrorResponseBody1Code;
    /**
     *
     * @type {string}
     * @memberof TimeoutErrorResponseBody
     */
    'details': string;
}
/**
 *
 * @export
 * @interface UnauthorizedErrorResponseBody
 */
interface UnauthorizedErrorResponseBody {
    /**
     *
     * @type {UnauthorizedErrorResponseBody1Code}
     * @memberof UnauthorizedErrorResponseBody
     */
    'code': UnauthorizedErrorResponseBody1Code;
    /**
     *
     * @type {string}
     * @memberof UnauthorizedErrorResponseBody
     */
    'details': string;
}
/**
 *
 * @export
 * @interface UnauthorizedErrorResponseBody1
 */
interface UnauthorizedErrorResponseBody1 {
    /**
     *
     * @type {UnauthorizedErrorResponseBody1Code}
     * @memberof UnauthorizedErrorResponseBody1
     */
    'code': UnauthorizedErrorResponseBody1Code;
    /**
     *
     * @type {string}
     * @memberof UnauthorizedErrorResponseBody1
     */
    'details': string;
}
/**
 *
 * @export
 * @interface UnauthorizedErrorResponseBody1Code
 */
interface UnauthorizedErrorResponseBody1Code {
}
/**
 *
 * @export
 * @enum {string}
 */
declare const UnauthorizedErrorResponseBody1CodeAnyOf: {
    readonly UnauthorizedError: "unauthorized_error";
};
type UnauthorizedErrorResponseBody1CodeAnyOf = typeof UnauthorizedErrorResponseBody1CodeAnyOf[keyof typeof UnauthorizedErrorResponseBody1CodeAnyOf];
/**
 * V2Api - axios parameter creator
 * @export
 */
declare const V2ApiAxiosParamCreator: (configuration?: Configuration) => {
    /**
     *
     * @param {Set<string>} transitions
     * @param {number} version
     * @param {string} userIdentifier
     * @param {string} uid
     * @param {string} [groupIdentifier]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    blockTransitions: (transitions: Set<string>, version: number, userIdentifier: string, uid: string, groupIdentifier?: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @param {number} version
     * @param {string} userIdentifier
     * @param {string} uid
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    findBlocks: (version: number, userIdentifier: string, uid: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @param {number} version
     * @param {string} userIdentifier
     * @param {string} uid
     * @param {FlowIntent} intent
     * @param {string} [groupIdentifier]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    flowIntent: (version: number, userIdentifier: string, uid: string, intent: FlowIntent, groupIdentifier?: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @param {number} version
     * @param {string} userIdentifier
     * @param {string} sid
     * @param {'block'} [include]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    getFlow: (version: number, userIdentifier: string, sid: string, include?: 'block', options?: AxiosRequestConfig) => Promise<RequestArgs>;
};
/**
 * V2Api - functional programming interface
 * @export
 */
declare const V2ApiFp: (configuration?: Configuration) => {
    /**
     *
     * @param {Set<string>} transitions
     * @param {number} version
     * @param {string} userIdentifier
     * @param {string} uid
     * @param {string} [groupIdentifier]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    blockTransitions(transitions: Set<string>, version: number, userIdentifier: string, uid: string, groupIdentifier?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>>;
    /**
     *
     * @param {number} version
     * @param {string} userIdentifier
     * @param {string} uid
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    findBlocks(version: number, userIdentifier: string, uid: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<FindBlocks200Response>>;
    /**
     *
     * @param {number} version
     * @param {string} userIdentifier
     * @param {string} uid
     * @param {FlowIntent} intent
     * @param {string} [groupIdentifier]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    flowIntent(version: number, userIdentifier: string, uid: string, intent: FlowIntent, groupIdentifier?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>>;
    /**
     *
     * @param {number} version
     * @param {string} userIdentifier
     * @param {string} sid
     * @param {'block'} [include]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    getFlow(version: number, userIdentifier: string, sid: string, include?: 'block', options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<GetFlow200Response>>;
};
/**
 * V2Api - factory interface
 * @export
 */
declare const V2ApiFactory: (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) => {
    /**
     *
     * @param {Set<string>} transitions
     * @param {number} version
     * @param {string} userIdentifier
     * @param {string} uid
     * @param {string} [groupIdentifier]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    blockTransitions(transitions: Set<string>, version: number, userIdentifier: string, uid: string, groupIdentifier?: string, options?: any): AxiosPromise<void>;
    /**
     *
     * @param {number} version
     * @param {string} userIdentifier
     * @param {string} uid
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    findBlocks(version: number, userIdentifier: string, uid: string, options?: any): AxiosPromise<FindBlocks200Response>;
    /**
     *
     * @param {number} version
     * @param {string} userIdentifier
     * @param {string} uid
     * @param {FlowIntent} intent
     * @param {string} [groupIdentifier]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    flowIntent(version: number, userIdentifier: string, uid: string, intent: FlowIntent, groupIdentifier?: string, options?: any): AxiosPromise<void>;
    /**
     *
     * @param {number} version
     * @param {string} userIdentifier
     * @param {string} sid
     * @param {'block'} [include]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    getFlow(version: number, userIdentifier: string, sid: string, include?: 'block', options?: any): AxiosPromise<GetFlow200Response>;
};
/**
 * V2Api - object-oriented interface
 * @export
 * @class V2Api
 * @extends {BaseAPI}
 */
declare class V2Api extends BaseAPI {
    /**
     *
     * @param {Set<string>} transitions
     * @param {number} version
     * @param {string} userIdentifier
     * @param {string} uid
     * @param {string} [groupIdentifier]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V2Api
     */
    blockTransitions(transitions: Set<string>, version: number, userIdentifier: string, uid: string, groupIdentifier?: string, options?: AxiosRequestConfig): Promise<axios.AxiosResponse<void, any>>;
    /**
     *
     * @param {number} version
     * @param {string} userIdentifier
     * @param {string} uid
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V2Api
     */
    findBlocks(version: number, userIdentifier: string, uid: string, options?: AxiosRequestConfig): Promise<axios.AxiosResponse<FindBlocks200Response, any>>;
    /**
     *
     * @param {number} version
     * @param {string} userIdentifier
     * @param {string} uid
     * @param {FlowIntent} intent
     * @param {string} [groupIdentifier]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V2Api
     */
    flowIntent(version: number, userIdentifier: string, uid: string, intent: FlowIntent, groupIdentifier?: string, options?: AxiosRequestConfig): Promise<axios.AxiosResponse<void, any>>;
    /**
     *
     * @param {number} version
     * @param {string} userIdentifier
     * @param {string} sid
     * @param {'block'} [include]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V2Api
     */
    getFlow(version: number, userIdentifier: string, sid: string, include?: 'block', options?: AxiosRequestConfig): Promise<axios.AxiosResponse<GetFlow200Response, any>>;
}

export { BadRequestErrorResponseBody, BadRequestErrorResponseBody1, BadRequestErrorResponseBody1Code, BadRequestErrorResponseBody1CodeAnyOf, BadRequestErrorResponseBody1CodeAnyOf1, BlockTransitionQueryString, BlockTransitionRequestParams, Configuration, ConfigurationParameters, FindBlocks200Response, FindBlocks200ResponseFieldsInner, FindBlocks200ResponseFieldsInnerAnyOf, FindBlocks200ResponseFieldsInnerAnyOf1, FindBlocks200ResponseFieldsInnerAnyOf1TypeEnum, FindBlocks200ResponseFieldsInnerAnyOf1Value, FindBlocks200ResponseFieldsInnerAnyOf2, FindBlocks200ResponseFieldsInnerAnyOf2TypeEnum, FindBlocks200ResponseFieldsInnerAnyOf2Value, FindBlocks200ResponseFieldsInnerAnyOfTypeEnum, FindBlocks200ResponseFieldsInnerAnyOfValue, FindBlocks200ResponseFieldsInnerTypeEnum, FindBlocks200ResponseKindEnum, FindBlocks200ResponseState, FindBlocks200ResponseTypeEnum, FinishIntent, FlowIntent, FlowIntentQueryString, FlowIntentRequestParams, GetBlockQueryString, GetBlockRequestParams, GetFlow200Response, GetFlow200ResponseKindEnum, GetFlow200ResponseState, GetFlow200ResponseTypeEnum, GetFlowQueryString, GetFlowQueryStringIncludeEnum, GetFlowRequestParams, HealthCheckResponseBody, InternalServerErrorResponseBody, InternalServerErrorResponseBody1, InternalServerErrorResponseBody1Code, InternalServerErrorResponseBody1CodeAnyOf, NotFoundErrorResponseBody, NotFoundErrorResponseBody1, NotFoundErrorResponseBody1Code, NotFoundErrorResponseBody1CodeAnyOf, ResetIntent, StartIntent, StopIntent, TimeoutErrorResponseBody, UnauthorizedErrorResponseBody, UnauthorizedErrorResponseBody1, UnauthorizedErrorResponseBody1Code, UnauthorizedErrorResponseBody1CodeAnyOf, V2Api, V2ApiAxiosParamCreator, V2ApiFactory, V2ApiFp };
