import globalAxios from 'axios';

/******************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */
/* global Reflect, Promise */

var extendStatics = function(d, b) {
    extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
    return extendStatics(d, b);
};

function __extends(d, b) {
    if (typeof b !== "function" && b !== null)
        throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
}

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};

function __awaiter(thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
}

function __generator(thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
}

/* tslint:disable */
var BASE_PATH = "http://blocks-api:7071".replace(/\/+$/, "");
/**
 *
 * @export
 * @class BaseAPI
 */
var BaseAPI = /** @class */ (function () {
    function BaseAPI(configuration, basePath, axios) {
        if (basePath === void 0) { basePath = BASE_PATH; }
        if (axios === void 0) { axios = globalAxios; }
        this.basePath = basePath;
        this.axios = axios;
        if (configuration) {
            this.configuration = configuration;
            this.basePath = configuration.basePath || this.basePath;
        }
    }
    return BaseAPI;
}());
/**
 *
 * @export
 * @class RequiredError
 * @extends {Error}
 */
var RequiredError = /** @class */ (function (_super) {
    __extends(RequiredError, _super);
    function RequiredError(field, msg) {
        var _this = _super.call(this, msg) || this;
        _this.field = field;
        _this.name = "RequiredError";
        return _this;
    }
    return RequiredError;
}(Error));

/* tslint:disable */
/**
 *
 * @export
 */
var DUMMY_BASE_URL = 'https://example.com';
/**
 *
 * @throws {RequiredError}
 * @export
 */
var assertParamExists = function (functionName, paramName, paramValue) {
    if (paramValue === null || paramValue === undefined) {
        throw new RequiredError(paramName, "Required parameter ".concat(paramName, " was null or undefined when calling ").concat(functionName, "."));
    }
};
/**
 *
 * @export
 */
var setApiKeyToObject = function (object, keyParamName, configuration) {
    return __awaiter(this, void 0, void 0, function () {
        var localVarApiKeyValue, _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    if (!(configuration && configuration.apiKey)) return [3 /*break*/, 5];
                    if (!(typeof configuration.apiKey === 'function')) return [3 /*break*/, 2];
                    return [4 /*yield*/, configuration.apiKey(keyParamName)];
                case 1:
                    _a = _b.sent();
                    return [3 /*break*/, 4];
                case 2: return [4 /*yield*/, configuration.apiKey];
                case 3:
                    _a = _b.sent();
                    _b.label = 4;
                case 4:
                    localVarApiKeyValue = _a;
                    object[keyParamName] = localVarApiKeyValue;
                    _b.label = 5;
                case 5: return [2 /*return*/];
            }
        });
    });
};
function setFlattenedQueryParams(urlSearchParams, parameter, key) {
    if (key === void 0) { key = ""; }
    if (typeof parameter === "object") {
        if (Array.isArray(parameter)) {
            parameter.forEach(function (item) { return setFlattenedQueryParams(urlSearchParams, item, key); });
        }
        else {
            Object.keys(parameter).forEach(function (currentKey) {
                return setFlattenedQueryParams(urlSearchParams, parameter[currentKey], "".concat(key).concat(key !== '' ? '.' : '').concat(currentKey));
            });
        }
    }
    else {
        if (urlSearchParams.has(key)) {
            urlSearchParams.append(key, parameter);
        }
        else {
            urlSearchParams.set(key, parameter);
        }
    }
}
/**
 *
 * @export
 */
var setSearchParams = function (url) {
    var objects = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        objects[_i - 1] = arguments[_i];
    }
    var searchParams = new URLSearchParams(url.search);
    setFlattenedQueryParams(searchParams, objects);
    url.search = searchParams.toString();
};
/**
 *
 * @export
 */
var toPathString = function (url) {
    return url.pathname + url.search + url.hash;
};
/**
 *
 * @export
 */
var createRequestFunction = function (axiosArgs, globalAxios, BASE_PATH, configuration) {
    return function (axios, basePath) {
        if (axios === void 0) { axios = globalAxios; }
        if (basePath === void 0) { basePath = BASE_PATH; }
        var axiosRequestArgs = __assign(__assign({}, axiosArgs.options), { url: ((configuration === null || configuration === void 0 ? void 0 : configuration.basePath) || basePath) + axiosArgs.url });
        return axios.request(axiosRequestArgs);
    };
};

/* tslint:disable */
/**
 *
 * @export
 * @enum {string}
 */
var BadRequestErrorResponseBody1CodeAnyOf = {
    InvalidRequestError: 'invalid_request_error'
};
/**
 *
 * @export
 * @enum {string}
 */
var BadRequestErrorResponseBody1CodeAnyOf1 = {
    IntentRequestError: 'intent_request_error'
};
var FindBlocks200ResponseKindEnum = {
    Block: 'block'
};
var FindBlocks200ResponseTypeEnum = {
    Model: 'model'
};
var FindBlocks200ResponseFieldsInnerTypeEnum = {
    Boolean: 'boolean'
};
var FindBlocks200ResponseFieldsInnerAnyOfTypeEnum = {
    String: 'string'
};
var FindBlocks200ResponseFieldsInnerAnyOf1TypeEnum = {
    Number: 'number'
};
var FindBlocks200ResponseFieldsInnerAnyOf2TypeEnum = {
    Boolean: 'boolean'
};
/**
 *
 * @export
 * @enum {string}
 */
var FinishIntent = {
    Finish: 'finish'
};
var GetFlow200ResponseKindEnum = {
    Flow: 'flow'
};
var GetFlow200ResponseTypeEnum = {
    Flow: 'flow'
};
var GetFlowQueryStringIncludeEnum = {
    Block: 'block'
};
/**
 *
 * @export
 * @enum {string}
 */
var InternalServerErrorResponseBody1CodeAnyOf = {
    InternalServerError: 'internal_server_error'
};
/**
 *
 * @export
 * @enum {string}
 */
var NotFoundErrorResponseBody1CodeAnyOf = {
    NotFoundError: 'not_found_error'
};
/**
 *
 * @export
 * @enum {string}
 */
var ResetIntent = {
    Reset: 'reset'
};
/**
 *
 * @export
 * @enum {string}
 */
var StartIntent = {
    Start: 'start'
};
/**
 *
 * @export
 * @enum {string}
 */
var StopIntent = {
    Stop: 'stop'
};
/**
 *
 * @export
 * @enum {string}
 */
var UnauthorizedErrorResponseBody1CodeAnyOf = {
    UnauthorizedError: 'unauthorized_error'
};
/**
 * V2Api - axios parameter creator
 * @export
 */
var V2ApiAxiosParamCreator = function (configuration) {
    var _this = this;
    return {
        /**
         *
         * @param {Set<string>} transitions
         * @param {number} version
         * @param {string} userIdentifier
         * @param {string} uid
         * @param {string} [groupIdentifier]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        blockTransitions: function (transitions, version, userIdentifier, uid, groupIdentifier, options) {
            if (options === void 0) { options = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var localVarPath, localVarUrlObj, baseOptions, localVarRequestOptions, localVarHeaderParameter, localVarQueryParameter, headersFromBaseOptions;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            // verify required parameter 'transitions' is not null or undefined
                            assertParamExists('blockTransitions', 'transitions', transitions);
                            // verify required parameter 'version' is not null or undefined
                            assertParamExists('blockTransitions', 'version', version);
                            // verify required parameter 'userIdentifier' is not null or undefined
                            assertParamExists('blockTransitions', 'userIdentifier', userIdentifier);
                            // verify required parameter 'uid' is not null or undefined
                            assertParamExists('blockTransitions', 'uid', uid);
                            localVarPath = "/v2/block/{uid}/transition"
                                .replace("{".concat("uid", "}"), encodeURIComponent(String(uid)));
                            localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
                            if (configuration) {
                                baseOptions = configuration.baseOptions;
                            }
                            localVarRequestOptions = __assign(__assign({ method: 'POST' }, baseOptions), options);
                            localVarHeaderParameter = {};
                            localVarQueryParameter = {};
                            // authentication ApiKeyAuth required
                            return [4 /*yield*/, setApiKeyToObject(localVarHeaderParameter, "X-Api-Key", configuration)];
                        case 1:
                            // authentication ApiKeyAuth required
                            _a.sent();
                            if (transitions) {
                                localVarQueryParameter['transitions'] = Array.from(transitions);
                            }
                            if (version !== undefined) {
                                localVarQueryParameter['version'] = version;
                            }
                            if (userIdentifier !== undefined) {
                                localVarQueryParameter['userIdentifier'] = userIdentifier;
                            }
                            if (groupIdentifier !== undefined) {
                                localVarQueryParameter['groupIdentifier'] = groupIdentifier;
                            }
                            setSearchParams(localVarUrlObj, localVarQueryParameter);
                            headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
                            localVarRequestOptions.headers = __assign(__assign(__assign({}, localVarHeaderParameter), headersFromBaseOptions), options.headers);
                            return [2 /*return*/, {
                                    url: toPathString(localVarUrlObj),
                                    options: localVarRequestOptions,
                                }];
                    }
                });
            });
        },
        /**
         *
         * @param {number} version
         * @param {string} userIdentifier
         * @param {string} uid
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        findBlocks: function (version, userIdentifier, uid, options) {
            if (options === void 0) { options = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var localVarPath, localVarUrlObj, baseOptions, localVarRequestOptions, localVarHeaderParameter, localVarQueryParameter, headersFromBaseOptions;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            // verify required parameter 'version' is not null or undefined
                            assertParamExists('findBlocks', 'version', version);
                            // verify required parameter 'userIdentifier' is not null or undefined
                            assertParamExists('findBlocks', 'userIdentifier', userIdentifier);
                            // verify required parameter 'uid' is not null or undefined
                            assertParamExists('findBlocks', 'uid', uid);
                            localVarPath = "/v2/block/{uid}"
                                .replace("{".concat("uid", "}"), encodeURIComponent(String(uid)));
                            localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
                            if (configuration) {
                                baseOptions = configuration.baseOptions;
                            }
                            localVarRequestOptions = __assign(__assign({ method: 'GET' }, baseOptions), options);
                            localVarHeaderParameter = {};
                            localVarQueryParameter = {};
                            // authentication ApiKeyAuth required
                            return [4 /*yield*/, setApiKeyToObject(localVarHeaderParameter, "X-Api-Key", configuration)];
                        case 1:
                            // authentication ApiKeyAuth required
                            _a.sent();
                            if (version !== undefined) {
                                localVarQueryParameter['version'] = version;
                            }
                            if (userIdentifier !== undefined) {
                                localVarQueryParameter['userIdentifier'] = userIdentifier;
                            }
                            setSearchParams(localVarUrlObj, localVarQueryParameter);
                            headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
                            localVarRequestOptions.headers = __assign(__assign(__assign({}, localVarHeaderParameter), headersFromBaseOptions), options.headers);
                            return [2 /*return*/, {
                                    url: toPathString(localVarUrlObj),
                                    options: localVarRequestOptions,
                                }];
                    }
                });
            });
        },
        /**
         *
         * @param {number} version
         * @param {string} userIdentifier
         * @param {string} uid
         * @param {FlowIntent} intent
         * @param {string} [groupIdentifier]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        flowIntent: function (version, userIdentifier, uid, intent, groupIdentifier, options) {
            if (options === void 0) { options = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var localVarPath, localVarUrlObj, baseOptions, localVarRequestOptions, localVarHeaderParameter, localVarQueryParameter, headersFromBaseOptions;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            // verify required parameter 'version' is not null or undefined
                            assertParamExists('flowIntent', 'version', version);
                            // verify required parameter 'userIdentifier' is not null or undefined
                            assertParamExists('flowIntent', 'userIdentifier', userIdentifier);
                            // verify required parameter 'uid' is not null or undefined
                            assertParamExists('flowIntent', 'uid', uid);
                            // verify required parameter 'intent' is not null or undefined
                            assertParamExists('flowIntent', 'intent', intent);
                            localVarPath = "/v2/flow/{uid}/{intent}"
                                .replace("{".concat("uid", "}"), encodeURIComponent(String(uid)))
                                .replace("{".concat("intent", "}"), encodeURIComponent(String(intent)));
                            localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
                            if (configuration) {
                                baseOptions = configuration.baseOptions;
                            }
                            localVarRequestOptions = __assign(__assign({ method: 'POST' }, baseOptions), options);
                            localVarHeaderParameter = {};
                            localVarQueryParameter = {};
                            // authentication ApiKeyAuth required
                            return [4 /*yield*/, setApiKeyToObject(localVarHeaderParameter, "X-Api-Key", configuration)];
                        case 1:
                            // authentication ApiKeyAuth required
                            _a.sent();
                            if (version !== undefined) {
                                localVarQueryParameter['version'] = version;
                            }
                            if (userIdentifier !== undefined) {
                                localVarQueryParameter['userIdentifier'] = userIdentifier;
                            }
                            if (groupIdentifier !== undefined) {
                                localVarQueryParameter['groupIdentifier'] = groupIdentifier;
                            }
                            setSearchParams(localVarUrlObj, localVarQueryParameter);
                            headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
                            localVarRequestOptions.headers = __assign(__assign(__assign({}, localVarHeaderParameter), headersFromBaseOptions), options.headers);
                            return [2 /*return*/, {
                                    url: toPathString(localVarUrlObj),
                                    options: localVarRequestOptions,
                                }];
                    }
                });
            });
        },
        /**
         *
         * @param {number} version
         * @param {string} userIdentifier
         * @param {string} sid
         * @param {'block'} [include]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getFlow: function (version, userIdentifier, sid, include, options) {
            if (options === void 0) { options = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var localVarPath, localVarUrlObj, baseOptions, localVarRequestOptions, localVarHeaderParameter, localVarQueryParameter, headersFromBaseOptions;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            // verify required parameter 'version' is not null or undefined
                            assertParamExists('getFlow', 'version', version);
                            // verify required parameter 'userIdentifier' is not null or undefined
                            assertParamExists('getFlow', 'userIdentifier', userIdentifier);
                            // verify required parameter 'sid' is not null or undefined
                            assertParamExists('getFlow', 'sid', sid);
                            localVarPath = "/v2/flow/{sid}"
                                .replace("{".concat("sid", "}"), encodeURIComponent(String(sid)));
                            localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
                            if (configuration) {
                                baseOptions = configuration.baseOptions;
                            }
                            localVarRequestOptions = __assign(__assign({ method: 'GET' }, baseOptions), options);
                            localVarHeaderParameter = {};
                            localVarQueryParameter = {};
                            // authentication ApiKeyAuth required
                            return [4 /*yield*/, setApiKeyToObject(localVarHeaderParameter, "X-Api-Key", configuration)];
                        case 1:
                            // authentication ApiKeyAuth required
                            _a.sent();
                            if (version !== undefined) {
                                localVarQueryParameter['version'] = version;
                            }
                            if (include !== undefined) {
                                localVarQueryParameter['include'] = include;
                            }
                            if (userIdentifier !== undefined) {
                                localVarQueryParameter['userIdentifier'] = userIdentifier;
                            }
                            setSearchParams(localVarUrlObj, localVarQueryParameter);
                            headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
                            localVarRequestOptions.headers = __assign(__assign(__assign({}, localVarHeaderParameter), headersFromBaseOptions), options.headers);
                            return [2 /*return*/, {
                                    url: toPathString(localVarUrlObj),
                                    options: localVarRequestOptions,
                                }];
                    }
                });
            });
        },
    };
};
/**
 * V2Api - functional programming interface
 * @export
 */
var V2ApiFp = function (configuration) {
    var localVarAxiosParamCreator = V2ApiAxiosParamCreator(configuration);
    return {
        /**
         *
         * @param {Set<string>} transitions
         * @param {number} version
         * @param {string} userIdentifier
         * @param {string} uid
         * @param {string} [groupIdentifier]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        blockTransitions: function (transitions, version, userIdentifier, uid, groupIdentifier, options) {
            return __awaiter(this, void 0, void 0, function () {
                var localVarAxiosArgs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, localVarAxiosParamCreator.blockTransitions(transitions, version, userIdentifier, uid, groupIdentifier, options)];
                        case 1:
                            localVarAxiosArgs = _a.sent();
                            return [2 /*return*/, createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)];
                    }
                });
            });
        },
        /**
         *
         * @param {number} version
         * @param {string} userIdentifier
         * @param {string} uid
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        findBlocks: function (version, userIdentifier, uid, options) {
            return __awaiter(this, void 0, void 0, function () {
                var localVarAxiosArgs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, localVarAxiosParamCreator.findBlocks(version, userIdentifier, uid, options)];
                        case 1:
                            localVarAxiosArgs = _a.sent();
                            return [2 /*return*/, createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)];
                    }
                });
            });
        },
        /**
         *
         * @param {number} version
         * @param {string} userIdentifier
         * @param {string} uid
         * @param {FlowIntent} intent
         * @param {string} [groupIdentifier]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        flowIntent: function (version, userIdentifier, uid, intent, groupIdentifier, options) {
            return __awaiter(this, void 0, void 0, function () {
                var localVarAxiosArgs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, localVarAxiosParamCreator.flowIntent(version, userIdentifier, uid, intent, groupIdentifier, options)];
                        case 1:
                            localVarAxiosArgs = _a.sent();
                            return [2 /*return*/, createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)];
                    }
                });
            });
        },
        /**
         *
         * @param {number} version
         * @param {string} userIdentifier
         * @param {string} sid
         * @param {'block'} [include]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getFlow: function (version, userIdentifier, sid, include, options) {
            return __awaiter(this, void 0, void 0, function () {
                var localVarAxiosArgs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, localVarAxiosParamCreator.getFlow(version, userIdentifier, sid, include, options)];
                        case 1:
                            localVarAxiosArgs = _a.sent();
                            return [2 /*return*/, createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)];
                    }
                });
            });
        },
    };
};
/**
 * V2Api - factory interface
 * @export
 */
var V2ApiFactory = function (configuration, basePath, axios) {
    var localVarFp = V2ApiFp(configuration);
    return {
        /**
         *
         * @param {Set<string>} transitions
         * @param {number} version
         * @param {string} userIdentifier
         * @param {string} uid
         * @param {string} [groupIdentifier]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        blockTransitions: function (transitions, version, userIdentifier, uid, groupIdentifier, options) {
            return localVarFp.blockTransitions(transitions, version, userIdentifier, uid, groupIdentifier, options).then(function (request) { return request(axios, basePath); });
        },
        /**
         *
         * @param {number} version
         * @param {string} userIdentifier
         * @param {string} uid
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        findBlocks: function (version, userIdentifier, uid, options) {
            return localVarFp.findBlocks(version, userIdentifier, uid, options).then(function (request) { return request(axios, basePath); });
        },
        /**
         *
         * @param {number} version
         * @param {string} userIdentifier
         * @param {string} uid
         * @param {FlowIntent} intent
         * @param {string} [groupIdentifier]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        flowIntent: function (version, userIdentifier, uid, intent, groupIdentifier, options) {
            return localVarFp.flowIntent(version, userIdentifier, uid, intent, groupIdentifier, options).then(function (request) { return request(axios, basePath); });
        },
        /**
         *
         * @param {number} version
         * @param {string} userIdentifier
         * @param {string} sid
         * @param {'block'} [include]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getFlow: function (version, userIdentifier, sid, include, options) {
            return localVarFp.getFlow(version, userIdentifier, sid, include, options).then(function (request) { return request(axios, basePath); });
        },
    };
};
/**
 * V2Api - object-oriented interface
 * @export
 * @class V2Api
 * @extends {BaseAPI}
 */
var V2Api = /** @class */ (function (_super) {
    __extends(V2Api, _super);
    function V2Api() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     *
     * @param {Set<string>} transitions
     * @param {number} version
     * @param {string} userIdentifier
     * @param {string} uid
     * @param {string} [groupIdentifier]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V2Api
     */
    V2Api.prototype.blockTransitions = function (transitions, version, userIdentifier, uid, groupIdentifier, options) {
        var _this = this;
        return V2ApiFp(this.configuration).blockTransitions(transitions, version, userIdentifier, uid, groupIdentifier, options).then(function (request) { return request(_this.axios, _this.basePath); });
    };
    /**
     *
     * @param {number} version
     * @param {string} userIdentifier
     * @param {string} uid
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V2Api
     */
    V2Api.prototype.findBlocks = function (version, userIdentifier, uid, options) {
        var _this = this;
        return V2ApiFp(this.configuration).findBlocks(version, userIdentifier, uid, options).then(function (request) { return request(_this.axios, _this.basePath); });
    };
    /**
     *
     * @param {number} version
     * @param {string} userIdentifier
     * @param {string} uid
     * @param {FlowIntent} intent
     * @param {string} [groupIdentifier]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V2Api
     */
    V2Api.prototype.flowIntent = function (version, userIdentifier, uid, intent, groupIdentifier, options) {
        var _this = this;
        return V2ApiFp(this.configuration).flowIntent(version, userIdentifier, uid, intent, groupIdentifier, options).then(function (request) { return request(_this.axios, _this.basePath); });
    };
    /**
     *
     * @param {number} version
     * @param {string} userIdentifier
     * @param {string} sid
     * @param {'block'} [include]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof V2Api
     */
    V2Api.prototype.getFlow = function (version, userIdentifier, sid, include, options) {
        var _this = this;
        return V2ApiFp(this.configuration).getFlow(version, userIdentifier, sid, include, options).then(function (request) { return request(_this.axios, _this.basePath); });
    };
    return V2Api;
}(BaseAPI));

/* tslint:disable */
/* eslint-disable */
/**
 * Dopt Blocks API
 * The Dopt Blocks API
 *
 * The version of the OpenAPI document: 0.0.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
var Configuration = /** @class */ (function () {
    function Configuration(param) {
        if (param === void 0) { param = {}; }
        this.apiKey = param.apiKey;
        this.username = param.username;
        this.password = param.password;
        this.accessToken = param.accessToken;
        this.basePath = param.basePath;
        this.baseOptions = param.baseOptions;
        this.formDataCtor = param.formDataCtor;
    }
    /**
     * Check if the given MIME is a JSON MIME.
     * JSON MIME examples:
     *   application/json
     *   application/json; charset=UTF8
     *   APPLICATION/JSON
     *   application/vnd.company+json
     * @param mime - MIME (Multipurpose Internet Mail Extensions)
     * @return True if the given MIME is JSON, false otherwise.
     */
    Configuration.prototype.isJsonMime = function (mime) {
        var jsonMime = new RegExp('^(application\/json|[^;/ \t]+\/[^;/ \t]+[+]json)[ \t]*(;.*)?$', 'i');
        return mime !== null && (jsonMime.test(mime) || mime.toLowerCase() === 'application/json-patch+json');
    };
    return Configuration;
}());

export { BadRequestErrorResponseBody1CodeAnyOf, BadRequestErrorResponseBody1CodeAnyOf1, Configuration, FindBlocks200ResponseFieldsInnerAnyOf1TypeEnum, FindBlocks200ResponseFieldsInnerAnyOf2TypeEnum, FindBlocks200ResponseFieldsInnerAnyOfTypeEnum, FindBlocks200ResponseFieldsInnerTypeEnum, FindBlocks200ResponseKindEnum, FindBlocks200ResponseTypeEnum, FinishIntent, GetFlow200ResponseKindEnum, GetFlow200ResponseTypeEnum, GetFlowQueryStringIncludeEnum, InternalServerErrorResponseBody1CodeAnyOf, NotFoundErrorResponseBody1CodeAnyOf, ResetIntent, StartIntent, StopIntent, UnauthorizedErrorResponseBody1CodeAnyOf, V2Api, V2ApiAxiosParamCreator, V2ApiFactory, V2ApiFp };
